
RenderTable = {}
Unrendered = {}

max_roundness = 20 

function insert_element(class,name,layer,x,y,w,h,colortable,line,drawmode,align)  --The class can only be the strings used for rendering the elements from render_elements function.
--line can be a string, table, etc and can be used for various things. Be sure to take a look inside render_elements function to know what to input for inserting elements
--Some variables are used in an unusual way for some shapes!
--colortable has to be a table with r,g,b,a colors inside (Ex. {100,255,10,255})
--align is only used for printf
if class == "Image" then 
i = love.graphics.newImage(line)
else i = nil end
Ent = {class = class,
        name = name,
        posX = x,
		posY = y,
		sizeW = w,
		sizeH = h,
		colors = colortable,
		drawmode = drawmode,
		line = line,
		layer = layer,
		image = i,
		align = align}
table.insert(RenderTable, Ent)
end

function find(class, name, table) --Returns the position of an element inside of a table so it this can be used: i = list(class, name)
 for i = 1,#table do
  if table[i] .class == class and table[i] .name == name then
  return i
  end
 end
end

function render_elements()
for u = 0,4 do
 for i = 1,#RenderTable do
 local ele = RenderTable[i] 
 if ele.layer == u then
 love.graphics.setColor(ele.colors[1], ele.colors[2], ele.colors[3], ele.colors[4])
  if ele.class == "Rectangle" then
    love.graphics.rectangle(ele.drawmode, ele.posX, ele.posY, ele.sizeW, ele.sizeH)
  elseif ele.class == "RoundRectangle" then
    love.graphics.rectangle(ele.drawmode, ele.posX, ele.posY, ele.sizeW, ele.sizeH, ele.line[1], ele.line[2], max_roundness)
  elseif ele.class == "Circle" then
    love.graphics.circle(ele.drawmode, ele.posX, ele.posY, ele.sizeW + ele.sizeH, max_roundness)
  elseif ele.class == "Polygon" then
    local vertices = {}
	for i = 1,#ele.line do
	table.insert(vertices, ele.line[i])
	end
    love.graphics.polygon(ele.drawmode, vertices)
  elseif ele.class == "Text" then
    love.graphics.print(ele.line, ele.posX, ele.posY)
  elseif ele.class == "Image" then
    love.graphics.draw(ele.image, ele.posX, ele.posY, ele.line[1], ele.line[2], ele.line[3])
  elseif ele.class == "Line" then
    love.graphics.line(ele.posX, ele.posY)
  elseif ele.class == "FormattedText" then
    love.graphics.printf(ele.line, ele.posX, ele.posY, ele.sizeW, ele.align)
  end
 end
 end
end
end

function edit_element(class,name,layer,x,y,w,h,colortable,line,drawmode,align) --You might not need some of these variables for some classes. You can leave them blank with "" or something else to avoid confusion in the future
i = find(class, name, RenderTable)
 local ele = RenderTable[i] 
  if ele.class == class and ele.name == name then
    name = name
    posX = x
    posY = y
	sizeW = w
	sizeH = h
	colors = colortable
	drawmode = drawmode
	line = line
	layer = layer
	image = i
	align = align
  end
end

function element_return(class, name, table, variable) --Returns a variable of your choice from an element (Ex. variables from inside Ent from insert_element function)
i = list(class, name, table)
 local ele = table[i] 
  if table[i].class == class and table[i] .name == name then
   return ele.variable
  end
end

function disappear_element(class, name) --Makes an element disappear without deleting it (Warning: Untested)
i = list(class, name, RenderTable)
  if RenderTable[i].class == class and RenderTable[i] .name == name then
   table.insert(Unrendered, RenderTable[i])
   table.remove(RenderTable[i])
  end
end

function appear_element(class, name) --Makes an element appear without deleting it (Warning: Untested)
i = list(class, name, Unrendered)
  if Unrendered[i].class == class and Unrendered[i] .name == name then
   table.insert(RenderTable, Unrendered[i])
   table.remove(Unrendered[i])
  end
end

function delete_element(class, name, table) --Deletes an element of your choice from a table
 for i = 1,#table do
 local ele = table[i] 
  if ele.class == class and ele.name == name then
   table.remove(table, i)
  end
 end
end

function delete_all_elements() --Deletes everything
for i = 1,#RenderTable do
 table.remove(RenderTable, i)
end
for i = 1,#Unrendered do
 table.remove(Unrendered, i)
end
end

